function dndV = compute_density_distsmooth(y)

%computes density distributions of oxidant and reduced species
% NOTE: this code employs a sequential averaging technique to smooth the
% distribution!  Basically, each point in the distribution is the average
% of four points (a,b,c,d), and the next point is the average of the next
% four points pushed over by 1 (b,c,d,e).

global N rgb 

%set all counting variables
a = 0;
b = 0;
c = 0;
d = 0;
e = 0;
f = 0;
g = 0;
h = 0;
j = 0;
k = 0;
l = 0;
m = 0;
n = 0;
o = 0;
p = 0;
q = 0;
r = 0;
s = 0;

%count particles in each category for oxidants
for i = 1:N
    if rgb(i) == 1
        continue
    end
    
    if y(2*i-1) <= 2
        a = a + 1;
    end
    if y(2*i-1) > 0 && y(2*i-1) <= 4
        b = b + 1;
    end
    if y(2*i-1) > 1 && y(2*i-1) <= 5
        c = c + 1;
    end
    if y(2*i-1) > 2 && y(2*i-1) <= 6
        d = d + 1;
    end
    if y(2*i-1) > 3 && y(2*i-1) <= 7
        e = e + 1;    
    end
    if y(2*i-1) > 4 && y(2*i-1) <= 8
        f = f + 1;  
    end
    if y(2*i-1) > 5 && y(2*i-1) <= 9
        g = g + 1; 
    end
    if y(2*i-1) > 6 && y(2*i-1) <= 10
        h = h + 1;  
    end
    if y(2*i-1) > 7 && y(2*i-1) <= 11
        j = j + 1;   
    end
    if y(2*i-1) > 8 && y(2*i-1) <= 12
        k = k + 1;
    end
    if y(2*i-1) > 9 && y(2*i-1) <= 13
        l = l + 1;    
    end
    if y(2*i-1) > 10 && y(2*i-1) <= 14
        m = m + 1;   
    end
    if y(2*i-1) > 11 && y(2*i-1) <= 15
        n = n + 1;  
    end
    if y(2*i-1) > 12 && y(2*i-1) <= 16
        o = o + 1;  
    end
    if y(2*i-1) > 13 && y(2*i-1) <= 17
        p = p + 1; 
    end
    if y(2*i-1) > 14 && y(2*i-1) <= 18
        q = q + 1; 
    end
    if y(2*i-1) > 15 && y(2*i-1) <= 19
        r = r + 1;  
    end
    if y(2*i-1) > 16 && y(2*i-1) <= 20
        s = s + 1;  
    end
end

%save as vector; divide by number of intervals to obtain average
counterblue = [a/2; b/4; c/4; d/4; e/4; f/4; g/4; h/4; j/4; k/4; l/4; m/4; n/4; o/4; p/4; q/4; r/4; s/4];

%reset counting variables for determination of reduced species
a = 0;
b = 0;
c = 0;
d = 0;
e = 0;
f = 0;
g = 0;
h = 0;
j = 0;
k = 0;
l = 0;
m = 0;
n = 0;
o = 0;
p = 0;
q = 0;
r = 0;
s = 0;

%count particles in each category for reduced species
for i = 1:N
    if rgb(i) == 0
        continue
    end
    
    if y(2*i-1) <= 2
        a = a + 1;
    end
    if y(2*i-1) > 0 && y(2*i-1) <= 4
        b = b + 1;
    end
    if y(2*i-1) > 1 && y(2*i-1) <= 5
        c = c + 1;
    end
    if y(2*i-1) > 2 && y(2*i-1) <= 6
        d = d + 1;
    end
    if y(2*i-1) > 3 && y(2*i-1) <= 7
        e = e + 1;    
    end
    if y(2*i-1) > 4 && y(2*i-1) <= 8
        f = f + 1;  
    end
    if y(2*i-1) > 5 && y(2*i-1) <= 9
        g = g + 1; 
    end
    if y(2*i-1) > 6 && y(2*i-1) <= 10
        h = h + 1;  
    end
    if y(2*i-1) > 7 && y(2*i-1) <= 11
        j = j + 1;   
    end
    if y(2*i-1) > 8 && y(2*i-1) <= 12
        k = k + 1;
    end
    if y(2*i-1) > 9 && y(2*i-1) <= 13
        l = l + 1;    
    end
    if y(2*i-1) > 10 && y(2*i-1) <= 14
        m = m + 1;   
    end
    if y(2*i-1) > 11 && y(2*i-1) <= 15
        n = n + 1;  
    end
    if y(2*i-1) > 12 && y(2*i-1) <= 16
        o = o + 1;  
    end
    if y(2*i-1) > 13 && y(2*i-1) <= 17
        p = p + 1; 
    end
    if y(2*i-1) > 14 && y(2*i-1) <= 18
        q = q + 1; 
    end
    if y(2*i-1) > 15 && y(2*i-1) <= 19
        r = r + 1;  
    end
    if y(2*i-1) > 16 && y(2*i-1) <= 20
        s = s + 1;  
    end

end

%save in a vector
counterred = [a/2; b/4; c/4; d/4; e/4; f/4; g/4; h/4; j/4; k/4; l/4; m/4; n/4; o/4; p/4; q/4; r/4; s/4];
redx = [1; 2; 3; 4; 5; 6; 7; 8; 9; 10; 11; 12; 13; 14; 15; 16; 17; 18];

%plot the two distributions, setting the oxidant distribution as a blue bar
%graph and the reduced species distribution as red points.  The two
%distribtions are overlaid, and subplotted with the particle positions
subplot(2,1,2);
bar(counterblue)
set(gca,'XLim',[0 19],'YLim',[0 7]);
ylabel('Particle density')
hold on;
plot(redx,counterred,'r.','MarkerSize',10);
        
        
        
